net.sf.saxon.om

## Class AtomicArray

- java.lang.Object
- - net.sf.saxon.om.AtomicArray

- All Implemented Interfaces:
    AtomicSequence, GroundedValue, Sequence

      public class AtomicArray
      extends Object
      implements AtomicSequence

  A sequence of atomic values, implemented using an underlying array. Often used for representing the typed value of a list-valued node.
  Since:
    9.5

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AtomicArray(AtomicValue[] content)` Create an AtomicArray over a supplied array of atomic values
    `AtomicArray(SequenceIterator iter)` Create an AtomicArray supplying the contents as an iterator

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `effectiveBooleanValue()` Get the effective boolean value of this sequence
    `CharSequence` | `getCanonicalLexicalRepresentation()` Get the canonical lexical representation as defined in XML Schema.
    `int` | `getLength()` Get the length of the sequence
    `Comparable` | `getSchemaComparable()` Get a Comparable value that implements the XML Schema ordering comparison semantics for this value.
    `String` | `getStringValue()` Get the string value of this sequence.
    `CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
    `AtomicValue` | `head()` Get the first item in the sequence.
    `AtomicValue` | `itemAt(int n)` Get the n'th item in the sequence (base-zero addressing)
    `SequenceIterator<AtomicValue>` | `iterate()` Get an iterator performance characteristics, though all should exhibit the same behaviour.over all the items in the sequence
    `GroundedValue` | `reduce()` Reduce the sequence to its simplest form.
    `AtomicArray` | `subsequence(int start, int length)` Get a subsequence of this sequence

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AtomicArray

          public AtomicArray(AtomicValue[] content)

      Create an AtomicArray over a supplied array of atomic values
      Parameters:
        `content` - the supplied array

    - #### AtomicArray

          public AtomicArray(SequenceIterator iter)
                      throws XPathException

      Create an AtomicArray supplying the contents as an iterator
      Parameters:
        `iter` - the iterator that supplies the values (which must be position at the start of the sequence, and which will be consumed by the method).
      Throws:
        `XPathException` - if evaluation of the SequenceIterator fails, or if any of the items returned by the SequenceIterator is not atomic

  - ### Method Detail

    - #### head

          public AtomicValue head()

      Description copied from interface: `Sequence`
      Get the first item in the sequence.
      Specified by:
        `head` in interface `AtomicSequence`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence if there is one, or null if the sequence is empty

    - #### iterate

          public SequenceIterator<AtomicValue> iterate()

      Description copied from interface: `Sequence`
      Get an iterator performance characteristics, though all should exhibit the same behaviour.over all the items in the sequence
      Specified by:
        `iterate` in interface `AtomicSequence`
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        an iterator over all the items

    - #### itemAt

          public AtomicValue itemAt(int n)

      Get the n'th item in the sequence (base-zero addressing)
      Specified by:
        `itemAt` in interface `AtomicSequence`
      Specified by:
        `itemAt` in interface `GroundedValue`
      Parameters:
        `n` - the index of the required item, the first item being zero
      Returns:
        the n'th item if n is in range, or null otherwise

    - #### getLength

          public int getLength()

      Get the length of the sequence
      Specified by:
        `getLength` in interface `AtomicSequence`
      Specified by:
        `getLength` in interface `GroundedValue`
      Returns:
        the number of items in the sequence

    - #### subsequence

          public AtomicArray subsequence(int start,
                                int length)

      Get a subsequence of this sequence
      Specified by:
        `subsequence` in interface `GroundedValue`
      Parameters:
        `start` - the index of the first item to be included in the result, counting from zero. A negative value is taken as zero. If the value is beyond the end of the sequence, an empty sequence is returned
        `length` - the number of items to be included in the result. Specify Integer.MAX_VALUE to get the subsequence up to the end of the base sequence. If the value is negative, an empty sequence is returned. If the value goes off the end of the sequence, the result returns items up to the end of the sequence
      Returns:
        the required subsequence

    - #### getCanonicalLexicalRepresentation

          public CharSequence getCanonicalLexicalRepresentation()

      Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules.
      Specified by:
        `getCanonicalLexicalRepresentation` in interface `AtomicSequence`
      Returns:
        the canonical lexical representation if defined in XML Schema; otherwise, the result of casting to string according to the XPath 2.0 rules

    - #### getStringValueCS

          public CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `AtomicSequence`
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Returns:
        the string value of the sequence.

    - #### getStringValue

          public String getStringValue()

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValue` in interface `AtomicSequence`
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Returns:
        the string value of the sequence.

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()
                                        throws XPathException

      Description copied from interface: `GroundedValue`
      Get the effective boolean value of this sequence
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Returns:
        the effective boolean value
      Throws:
        `XPathException` - if the sequence has no effective boolean value (for example a sequence of two integers)

    - #### getSchemaComparable

          public Comparable getSchemaComparable()

      Get a Comparable value that implements the XML Schema ordering comparison semantics for this value. The default implementation is written to compare sequences of atomic values. This method is overridden for AtomicValue and its subclasses.

      In the case of data types that are partially ordered, the returned Comparable extends the standard semantics of the compareTo() method by returning the value `SequenceTool.INDETERMINATE_ORDERING` when there is no defined order relationship between two given values.

      For comparing key/keyref values, XSD 1.1 defines that a singleton list is equal to its only member. To achieve this, this method returns the schema comparable of the singleton member if the list has length one. This won't give the correct ordering semantics, but we rely on lists never taking part in ordering comparisons.

      Specified by:
        `getSchemaComparable` in interface `AtomicSequence`
      Returns:
        a Comparable that follows XML Schema comparison rules

    - #### reduce

          public GroundedValue reduce()

      Reduce the sequence to its simplest form. If the value is an empty sequence, the result will be EmptySequence.getInstance(). If the value is a single atomic value, the result will be an instance of AtomicValue. If the value is a single item of any other kind, the result will be an instance of SingletonItem. Otherwise, the result will typically be unchanged.
      Specified by:
        `reduce` in interface `GroundedValue`
      Returns:
        the simplified sequence

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.